package ui.view.product.core.components;

import java.awt.Dimension;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;
import ui.view.product.core.components.BlankIcon;
import ui.view.product.core.multilanguage.components.MLabel;
import ui.view.product.core.multilanguage.components.MMenu;
import ui.view.product.core.utils.ViewUtils;

public final class MenuBearingButton extends MLabel {

   private static final long serialVersionUID = 1L;
   private JLabel button = new JLabel();
   private MMenu mMenu = new MMenu();


   public MenuBearingButton() {
      final ImageIcon selectableIcon = ViewUtils.createImageIcon("btn_menu_selectable.png");
      final ImageIcon selectedIcon = ViewUtils.createImageIcon("btn_menu_selected.png");
      boolean buttonX = false;
      Dimension d = new Dimension(80, 42);
      this.setPreferredSize(d);
      this.setSize(d);
      this.setMaximumSize(d);
      this.setMinimumSize(d);
      this.setLayout((LayoutManager)null);
      this.button.setIcon(selectableIcon);
      this.button.setSize(this.button.getIcon().getIconWidth(), this.button.getIcon().getIconHeight());
      this.button.setLocation(0, (this.getHeight() - this.button.getIcon().getIconHeight()) / 2);
      this.add(this.button);
      BlankIcon blank = new BlankIcon(0, 0);
      this.setIcon(blank);
      this.setDisabledIcon(blank);
      this.setHorizontalTextPosition(4);
      this.setHorizontalAlignment(2);
      this.setIconTextGap(0 + this.button.getIcon().getIconWidth() + 6);
      this.button.addMouseListener(new MouseAdapter() {
         public void mousePressed(MouseEvent e) {
            JPopupMenu popup = MenuBearingButton.this.mMenu.getPopupMenu();
            if(!popup.isVisible() && MenuBearingButton.this.isEnabled()) {
               popup.show(MenuBearingButton.this.button, 0, MenuBearingButton.this.button.getHeight() + 3);
               MenuBearingButton.this.button.setIcon(selectedIcon);
            }

         }
      });
      this.mMenu.getPopupMenu().addPopupMenuListener(new PopupMenuListener() {
         public void popupMenuWillBecomeVisible(PopupMenuEvent e) {
         }
         public void popupMenuCanceled(PopupMenuEvent e) {
         }
         public void popupMenuWillBecomeInvisible(PopupMenuEvent e) {
            MenuBearingButton.this.button.setIcon(selectableIcon);
         }
      });
   }

   public JMenuItem add(JMenuItem item) {
      return this.mMenu.add(item);
   }

   public void setEnabled(boolean b) {
      this.button.setEnabled(b);
      super.setEnabled(b);
   }

   public void updateContents() {
      super.updateContents();
      this.mMenu.updateContents();
   }

   public static void main(String[] args) {
      JMenuBar bar = new JMenuBar();
      final MenuBearingButton menu1 = new MenuBearingButton();
      JMenuItem i1 = new JMenuItem("item1");
      JMenuItem i2 = new JMenuItem("item2");
      JMenuItem i3 = new JMenuItem("item3");
      menu1.add(i1);
      menu1.add(i2);
      menu1.add(i3);
      final MenuBearingButton menu2 = new MenuBearingButton();
      JMenuItem i11 = new JMenuItem("item1");
      JMenuItem i12 = new JMenuItem("item2");
      JMenuItem i13 = new JMenuItem("item3");
      menu2.add(i11);
      menu2.add(i12);
      menu2.add(i13);
      bar.add(menu1);
      bar.add(menu2);
      JFrame f = new JFrame("MenuBearingButton Test !!!");
      f.setJMenuBar(bar);
      f.setDefaultCloseOperation(3);
      final JLabel label = new JLabel();
      label.setIcon(new BlankIcon(40, 10));
      label.setDisabledIcon(new BlankIcon(40, 10));
      label.setHorizontalTextPosition(4);
      label.setHorizontalAlignment(2);
      label.setIconTextGap(50);
      label.setText("label label");
      JButton enableB = new JButton("enable");
      JButton disableB = new JButton("disable");
      enableB.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            menu1.setEnabled(true);
            menu2.setEnabled(true);
            label.setEnabled(true);
         }
      });
      disableB.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            menu1.setEnabled(false);
            menu2.setEnabled(false);
            label.setEnabled(false);
         }
      });
      f.getContentPane().add(enableB, "North");
      f.getContentPane().add(disableB, "South");
      f.setSize(400, 200);
      f.setVisible(true);
   }
}
